'
' ==========================================================================================
' QINPUTBOX                       by  ????????????                         November 2000
' ==========================================================================================
'
'       $INCLUDE "QInputBox.Inc"
'       Dim myInput As QInputBox
'
'       myInput.Show ("Enter the name of your City", "QInputForm.Caption",      "Bruxelles")
'
'                       promt                       InputBox.form.caption      default_return 
'                                                   "" &gt; application title   
'
'       return the string entered or the default value, in this case "Bruxelles"
'
'
'Description :
'       Displays a dialog box for user input. Returns the information entered in the dialog
'       box, or the Defaulf Value if nothing is entered
'
'Syntax:
'      expression.Show([Prompt], [Title], [Default])
'
'      expression Required:         An expression that returns an Application object
'      Prompt Optional String:      The message to be displayed in the dialog box. 
'      Title Optional String:       The title for the input box. If this argument is omitted, 
'                                                the default title is Application.Title
'      Default Optional String:     Specifies a text that will appear in the text box 
'                                                when the dialog box is initially displayed. 
'                                                If this argument is omitted, the text box
'                                                 is left empty.
'
'Usage: DIM Nane as QInputBox
'       retStr = Name.Show([Prompt], [Title], [Default])
'
' ===========================================================================================
' CODE
' ----

$Typecheck on

Type QInputBox extends QObject

Private:
    Form as Qform
    Prompt as Qlabel
    Edit as Qedit
    btnOk as QButton
    btnCancel as QButton
    DataIn as string
    DataOut as string

Public:    
    functioni Show(...) as string
       With QInputBox
          .DataOut = ""             'resets QinputBox
          'Parents 
          .Prompt.Parent = .Form  
          .Edit.Parent = .Form
          .btnOk.Parent = .Form
          .btnCancel.Parent = .Form
          'Form
          if ParamStr$(2) = "" then           
             .Form.Caption = application.title
          else
             .Form.Caption = ParamStr$(2)
          end if
          .Form.Width = 315
          .Form.Height = 150
          .Form.BorderStyle = 3 'bsDialog
          .Form.Center
          'Prompt
          if ParamStr$(1) = "" then
             .Prompt.Caption = "Prompt :"
          else
             .Prompt.Caption = ParamStr$(1) + " :" 
          end if
          .Prompt.Left = 15
          .Prompt.Top = 15
          .Prompt.AutoSize = 1
          .Prompt.Transparent = 1
          'EditBox
          .DataIn = ParamStr$(3)
          .Edit.Text = .DataIn
          .Edit.Left = 15
          .Edit.Top = 85
          .Edit.Width = 280
          .Edit.TabOrder = 0
          'OK button
          .btnOk.Caption = "&Ok"
          .btnOk.Left = 220
          .btnOk.Top = 10
          .btnOk.TabOrder = 1
          .btnOk.Kind = 1 'mbOK
          'Cancel button
          .btnCancel.Caption = "&Cancel"
          .btnCancel.Left = 220
          .btnCancel.Top = 40
          .btnCancel.TabOrder = 2
          .btnCancel.Kind = 2 'mbCancel
          'Show Qinputbox
          .Form.Showmodal
          Result = .DataOut
       End With
    end functioni
    
Private:    
    Event btnOk.Onclick (Sender as Qbutton)
       QInputBox.DataOut = QInputBox.Edit.text
    end event
    
    Event btnCancel.Onclick (Sender as Qbutton)
       QInputBox.DataOut = QInputBox.DataIn
    end event
    
    Event form.Onclose (Action as integer)
       if QInputBox.DataOut = "" then QInputBox.DataOut = QInputBox.DataIn
    end event   

end type  

$Typecheck off
